Knob={}
knobs={}
Knob.new=function(x,y,min,max,name,def)
 local self={x=x,y=y,min=min,max=max,name=name}
 self.at=(min+max)/2;
 if def~=nil then self.at=def end
 self.def=self.at
 table.insert(knobs,self)
 self.size=64
 local turnamount=180
 
 local lastmouse=false
 self.holding=false
 self.origin=-1

 self.update=function()
  local midx=self.x+(self.size/2)
  local midy=self.y+(self.size/2)
  local touching=((midx-love.mouse.getX())^2)+((midy-love.mouse.getY())^2)<(self.size/2)^2
  if(lastmouse==false and love.mouse.isDown("l") and touching) then
   self.holding=true
   self.origin=love.mouse.getY()
   if love.keyboard.isDown("backspace") then
    self.holding=false
    self.at=self.def
   end
  end
  if(self.holding) then
   if(not love.mouse.isDown("l")) then self.holding=false
   else
    local dif=love.mouse.getY()-self.origin
    self.origin=love.mouse.getY()
    dif=(dif/self.size)*(max-min)
    self.at=self.at+dif
   end
  end
  self.at=math.min(math.max(self.at,min),max)
  self.value=self.at
  
  lastmouse=love.mouse.isDown("l")
 end
 
 self.draw=function()
  g.setColor(150,150,150);
  g.circle("fill",self.x+(self.size/2),self.y+(self.size/2),self.size/2,self.size);
  g.setColor(255,127,0);
  g.circle("line",self.x+(self.size/2),self.y+(self.size/2),self.size/2,self.size);
  
  g.setColor(0,0,0);
  local rotation=((self.at-self.min)/(max-min))*turnamount
   -90-(turnamount/2)
  g.setFont(15);
  rotation=(rotation/180)*math.pi
  g.line(self.x+(self.size/2),self.y+(self.size/2),
	self.x+(self.size/2)+math.cos(rotation)*self.size*0.5,
	self.y+(self.size/2)+math.sin(rotation)*self.size*0.5);
  g.setColor(255,127,0); 
  g.printf(self.name,self.x+5,self.y+self.size,self.size,"center")
  local attext=math.floor(self.at*100)/100
  g.printf(attext,self.x+5,self.y+self.size+20,self.size,"center")
 end
 
 return self
end